

#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "ISO_Fortran_binding.h"
#include "qgraf.h"




 int main()
{

   int32_t  maxlen[A_SIZE];

   int  ij, k1, stylefiles, s1, s2;

   int64_t  lintc;

   char  ccs[CCS_L0];

   int32_t  csl[A_SIZE];

   CFI_CDESC_T(0)  ccsf;

   char  *ccs1[A_SIZE];

   FILE *fout1, *fout2;

   int  cfi_stat;

   char  c1;


/*   void  qinterf2018c;  */


   maxlen[0] = 4096 ;
   maxlen[1] = 2048 ;


/*  create CFI descriptor for string ccs  */

   cfi_stat = CFI_establish((CFI_cdesc_t *)&ccsf, (CFI_cdesc_t *)&ccs, CFI_attribute_pointer, CFI_type_char, 1, 0, NULL);

   printf("\n  cfi_status is now  %d\n", cfi_stat);



/*  some basic definitions  */


   stylefiles = 2 ;

   csl[0] = maxlen[0] ;
   csl[1] = maxlen[1] ;


/*  open two output files (for testing) */


   fout1 = fopen("out_tmp/pxq_out1","w");
   fout2 = fopen("out_tmp/pxq_out2","w");


/*  compute offsets  */
/*  size of char is assumed to be 1  */


   ccs1[0] = ccs;
   ij = 1;
   while ( ij < stylefiles ) {
      ccs1[ij]= ccs1[ij-1] +csl[ij-1];
      ij++ ;
   }


/*  initialize qgraf  */
/*  call Fortran to print onto the string  */

   memcpy(ccs1[0],"'q_api.dat'\0",13);

   s1 = qisgnl.init ;

   s2 = 0 ;

   qinterf2018c(&s1,&s2,(CFI_cdesc_t *)&ccsf,csl,&lintc);

/*   cfi_stat = CFI_deallocate((CFI_cdesc_t *)&ccsf);  */

   if ( s2 != qrsgnl.ok ) {
      printf("\n error_message:  %s\n\n", ccs1[0]);
      exit(1);
   }

   if ( lintc != (int64_t) stylefiles ) {
      printf("\n there was a problem with the initialization\n");
      printf("\n    stylefiles is  %d\n\n", stylefiles);
      printf("\n    lintc is  %d\n\n", lintc);
      exit(1);
   }


   printf("\n\n  initialization ok, version is:  %s \n\n",ccs1[0]);

   printf("  stylefiles is  %d\n\n", stylefiles);

   printf("\n enter any character to request prologue(s)\n");

   scanf("%c",&c1);

   printf("\n\n");



/*  in what follows, assume stylefiles equal to 2  */


   s1 = qisgnl.prologue ;

   csl[0] = qisgnl.y ;
   csl[1] = qisgnl.y ;

   qinterf2018c(&s1,&s2,(CFI_cdesc_t *)&ccsf,csl,&lintc);

   if ( s2 != qrsgnl.ok ) {
      printf("\n error_message:  %s\n\n", ccs1[0]);
      exit(1);
   }

   ij = -1;
   while ( ++ij < stylefiles ) {
      printf("\n length of expression %d is %d \n", ij+1, csl[ij]);
      if ( csl[ij] > 0 ) {
         printf("\n expression %d\n", ij+1);
         printf(".........................................................\n");
         printf("%s\n", ccs1[ij]);
         printf(".........................................................\n");
      }
   }



   printf("\n\n now enter any character to request the amplitudes\n \
   those for the first three diagrams will be displayed\n");

   scanf("%c\n",&c1);

   printf("\n\n");



/*  the expressions for the diagrams  */

   k1 = 0;
   s2 = qrsgnl.ok ;

   while ( s2 == qrsgnl.ok ) {

      s1 = qisgnl.diagram ;

      csl[0] = qisgnl.y ;
      csl[1] = qisgnl.y ;

      qinterf2018c(&s1,&s2,(CFI_cdesc_t *)&ccsf,csl,&lintc);

      if ( s2 == qrsgnl.ok ) {

         ++k1;
         ij = -1 ;
         while ( ++ij < stylefiles ) {
            if ( s2 != qrsgnl.end ) {
               if ( k1 < 4 ) {
                  printf(".........................................................\n");
                  printf("     diagram %d\n",k1);
                  printf("\n   expression %d ,  length %d ,  strlen= %d \n",ij+1,csl[ij],strlen(ccs1[ij]));
                  printf(".........................................................\n");
                  printf("%s\n",ccs1[ij]);
                  printf(".........................................................\n\n");
               }
            }
         }

         if ( csl[0] > 0 ) {
            fprintf(fout1,"%s\n",ccs1[0]);
         }

         if ( csl[1] > 0 ) {
            fprintf(fout2,"%s\n",ccs1[1]);
         }

      } else {

         if ( s2 == qrsgnl.end ) {
            printf("\n #diagrams = %d\n\n",lintc);
         } else {
            printf("\n error_message:  %s\n\n", ccs1[0]);
         }
      }

   }



/*  getting current msg_count  */

   s1 = qisgnl.msg_count ;

   qinterf2018c(&s1,&s2,(CFI_cdesc_t *)&ccsf,csl,&lintc);

   if ( s2 != qrsgnl.ok ) {
      printf("\n error_message:  %s\n\n", ccs1[0]);
      exit(1);
   } else {
      ij= (int32_t) lintc;
      printf("\n  current msg_count:  %d\n", ij);
   }


/*  stopping qgraf  */


   s1 = qisgnl.stop ;

   qinterf2018c(&s1,&s2,(CFI_cdesc_t *)&ccsf,csl,&lintc);

   if ( s2 != qrsgnl.ok ) {
      printf("\n error_message:  %s\n\n", ccs1[0]);
      exit(1);
   } else {
      printf("\n  qgraf has been stopped\n\n");
   }

   fclose(fout1);
   fclose(fout2);

   exit(0);

}

